<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/05/2005 *
 * ================                             Last change: 03/05/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-mediadata.php                                *
 * -------------------------------------------------------------------- *
 * Short description : More details media data                          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr detailiertere Mediendaten                   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Version number
EXT_SET_VERSION('0.0.9');

// Version history array (add more with , '0.1.0' and so on)
EXT_SET_VER_HISTORY(array('0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9'));

switch ($EXT_LOAD_MODE)
{
	case 'register': // Do stuff when installation is running (modules.php?module=admin is called)
		// SQL commands to run
		ADD_EXT_SQL('');
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		ADD_EXT_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_mediadata`");
		ADD_EXT_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_admin_menu` WHERE `what`='config_mediadata'");
		ADD_EXT_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_guest_menu` WHERE `what`='mediadata'");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		ADD_EXT_SQL('');
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		ADD_EXT_SQL('');
		break;

	case 'update': // Update an extension
		switch ($EXT_VER)
		{
			case '0.0.1': // SQL queries for v0.0.1
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Berechnung der Gesamt-{!POINTS!} korregiert.");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Daten des Scriptes mit eingebunden.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Sicherheitsupdate: SQL-Anweisungen gesch&uuml;tzt.");
				break;

			case '0.0.4': // SQL queries for v0.0.4
				// SQL commands to run
				ADD_EXT_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_mediadata`");
				ADD_EXT_SQL("CREATE TABLE `{!_MYSQL_PREFIX!}_mediadata` (
media_key VARCHAR(255) NOT NULL DEFAULT '',
media_value VARCHAR(255) NOT NULL DEFAULT '',
PRIMARY KEY(media_key)
) TYPE={!_TABLE_TYPE!}");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Teile der Mediendaten werden in seperater Tabelle gesichert. Bitte beachten Sie, dass dieses Update nur Daten des <strong>aktuellen</strong> Zustandes ber&uuml;cksichtigen kann und <strong>nicht</strong> bereits gel&ouml;schter Mitglieder.");
				break;

			case '0.0.5': // SQL queries for v0.0.5
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("if-Anweisungen auf Funktion <strong>empty()</strong> umgestellt.");
				break;

			case '0.0.6': // SQL queries for v0.0.6
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Mediendaten mussten komplett regeneriert werden.");
				break;

			case '0.0.7': // SQL queries for v0.0.7
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD mt_start BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");
				ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD mt_stage BIGINT(20) UNSIGNED NOT NULL DEFAULT '500'");
				ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('setup','config_mediadata','Mediendaten','Stellen Sie allgemeine Einstellungen zu den Mediendaten ein.', 10)");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Start des {!MT_WORD2!} und Anzahl Anmeldungen aufgenommen. (Task #13)<br />
Bitte stellen Sie diesen derzeit manuell unter <a href=\"{!URL!}/modules.php?module=admin&amp;what=config_mediadata\">Einstellungen-Medidata</a> selber einstellen.");
				break;

			case '0.0.8': // SQL queries for v0.0.8
				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Fehlerhinweis bei deaktivierter Erweiterung verbessert.");
				break;

			case '0.0.9': // SQL queries for v0.0.9
				ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_guest_menu` (`action`,`what`,`title`,`sort`,`visible`,`locked`) VALUES ('main','mediadata','Mediendaten',3,'Y','N')");

				// Update notes (these will be set as task text!)
				EXT_SET_UPDATE_NOTES("Men&uuml;punkt wird durch diese Erweiterung generiert.");
				break;
		}
		break;

			case 'modify': // When the extension got modified
				break;

			case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
				break;

			default: // Do stuff when extension is loaded
				break;
}

if ((isset($dry_run)) && (isset($EXT_LOAD_MODE))) {
	if ((!$dry_run) && ($EXT_LOAD_MODE == 'update') && ($EXT_VER == '0.0.4')) {
		// Add auto-check file
		ADD_INC_TO_POOL(sprintf("%sinc/gen_mediadata.php", constant('PATH')));
	} // END - if
} // END - if

// Keep this extension always active!
EXT_SET_ALWAYS_ACTIVE('Y');

//
?>
